std::queue< _Tp, _Sequence > Class Template Reference
Sequences

## Public Types

typedef _Sequence::const_reference | const_reference
typedef _Sequence | container_type
typedef _Sequence::reference | reference
typedef _Sequence::size_type | size_type
typedef _Sequence::value_type | value_type

## Public Member Functions

| queue (const _Sequence &__c)
reference | back ()
const_reference | back () const
template<typename... _Args>
void | emplace (_Args &&...__args)
reference | front ()
const_reference | front () const
void | noexcept (noexcept(swap(c, __q.c)))
void | pop ()
void | push (const value_type &__x)
void | push (value_type &&__x)
size_type | size () const

## Public Attributes

| __pad0__: c(std::move(__c)) { } bool empty() const { return c.empty()

## Protected Attributes

_Sequence | c

## Friends

template<typename _Tp1 , typename _Seq1 >
bool | operator< (const queue< _Tp1, _Seq1 > &, const queue< _Tp1, _Seq1 > &)
template<typename _Tp1 , typename _Seq1 >
bool | operator== (const queue< _Tp1, _Seq1 > &, const queue< _Tp1, _Seq1 > &)

## Detailed Description

### template<typename _Tp, typename _Sequence = deque<_Tp>>
class std::queue< _Tp, _Sequence >

A standard container giving FIFO behavior.

Template Parameters

  _Tp | Type of element.
  _Sequence | Type of underlying sequence, defaults to deque<_Tp>.

Meets many of the requirements of a container, but does not define anything to do with iterators. Very few of the other standard container interfaces are defined.

This is not a true container, but an adaptor. It holds another container, and provides a wrapper interface to that container. The wrapper is what enforces strict first-in-first-out queue behavior.

The second template parameter defines the type of the underlying sequence/container. It defaults to std::deque, but it can be any type that supports `front`, `back`, `push_back`, and `pop_front`, such as std::list or an appropriate user-defined type.

Members not found in normal containers are `container_type`, which is a typedef for the second Sequence parameter, and `push` and `pop`, which are standard queue/FIFO operations.

Definition at line 93 of file stl_queue.h.

## Constructor & Destructor Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

std::queue< _Tp, _Sequence >::queue | ( | const _Sequence & | __c | ) |

inlineexplicit

Default constructor creates no elements.

Definition at line 138 of file stl_queue.h.

## Member Function Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::queue< _Tp, _Sequence >::back | ( |  | ) |

inline

Returns a read/write reference to the data at the last element of the queue.

Definition at line 185 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::queue< _Tp, _Sequence >::back | ( |  | ) | const

inline

Returns a read-only (constant) reference to the data at the last element of the queue.

Definition at line 196 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

reference std::queue< _Tp, _Sequence >::front | ( |  | ) |

inline

Returns a read/write reference to the data at the first element of the queue.

Definition at line 163 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

const_reference std::queue< _Tp, _Sequence >::front | ( |  | ) | const

inline

Returns a read-only (constant) reference to the data at the first element of the queue.

Definition at line 174 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::queue< _Tp, _Sequence >::pop | ( |  | ) |

inline

Removes first element.

This is a typical queue operation. It shrinks the queue by one. The time complexity of the operation depends on the underlying sequence.

Note that no data is returned, and if the first element's data is needed, it should be retrieved before pop() is called.

Definition at line 238 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

void std::queue< _Tp, _Sequence >::push | ( | const value_type & | __x | ) |

inline

Add data to the end of the queue.

Parameters

  __x | Data to be added.

This is a typical queue operation. The function creates an element at the end of the queue and assigns the given data to it. The time complexity of the operation depends on the underlying sequence.

Definition at line 212 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

template<typename _Tp, typename _Sequence = deque<_Tp>>

size_type std::queue< _Tp, _Sequence >::size | ( |  | ) | const

inline

Returns the number of elements in the queue.

Definition at line 155 of file stl_queue.h.

References std::queue< _Tp, _Sequence >::c.

## Member Data Documentation

template<typename _Tp, typename _Sequence = deque<_Tp>>

_Sequence std::queue< _Tp, _Sequence >::c

protected

'c' is the underlying container. Maintainers wondering why this isn't uglified as per style guidelines should note that this name is specified in the standard, [23.2.3.1]. (Why? Presumably for the same reason that it's protected instead of private: to allow derivation. But none of the other containers allow for derivation. Odd.)

Definition at line 126 of file stl_queue.h.

Referenced by std::queue< _Tp, _Sequence >::back(), std::queue< _Tp, _Sequence >::front(), std::operator==(), std::queue< _Tp, _Sequence >::pop(), std::queue< _Tp, _Sequence >::push(), and std::queue< _Tp, _Sequence >::size().

The documentation for this class was generated from the following file:

- stl_queue.h